Name:           saga
Version:        2.0.8
Release:        8%{?dist}
Summary:        Geographic information system with an API for processing geodata 

Group:          Applications/Engineering

# libsaga_api is licensed under the terms of LGPLv2. So is one single
# module and some of the code to create documentation.
# The rest of the code is GPLv2, GPLv2+ or compatible (ISC, MIT/X11)
License:        GPLv2 and LGPLv2
URL:            http://www.saga-gis.org 
#Source0:        http://downloads.sourceforge.net/%%{name}/%%{name}_%%{version}.tar.gz
# Mailing list discussion on non-free components
# http://sourceforge.net/mailarchive/forum.php?thread_name=1322084398.4890.10.camel%40desktop.fritz.box&forum_name=saga-gis-developer
Source0:        %{name}_%{version}-fedora.tar.gz

#TODO: Submit
Source1:        %{name}.desktop

# Script to generate free tarball
# See comments inside
Source2:        %{name}_tarball.sh

# Patches 1, 2 and 6 are taken from Ubuntugis

# Use system-wide qhull
Patch1:     %{name}-2.0.8-adjust-grid_gridding-to-use-qhull.patch

# Firelib license does not allow commercial use
# Sources are excluded from tarball
# http://sourceforge.net/p/saga-gis/bugs/128/
Patch2:     %{name}-2.0.8-remove-references-to-libfire.patch

# Link to grib2 system library
Patch3:     %{name}-2.0.8-use-system-version-of-grib2.patch

# Use Fedora's static g2clib
# http://sourceforge.net/p/saga-gis/bugs/137/
Patch4:     %{name}-2.0.8-g2clib.patch

# Dxflib is not regarded free as of http://lists.fedoraproject.org/pipermail/legal/2011-October/001734.html
# Sources are excluded from tarball
# http://sourceforge.net/p/saga-gis/bugs/135/
Patch5:     %{name}-2.0.7-dxflib.patch

# Use system-wide e00compr
# http://sourceforge.net/p/saga-gis/bugs/137/
Patch6:     %{name}-2.0.8-e00.patch

# Use system-wide polyclipping
# http://sourceforge.net/p/saga-gis/bugs/135/
Patch7:     %{name}-2.0.8-poly.patch

# Use system-wide wxpropgrid
# http://sourceforge.net/p/saga-gis/bugs/137/
Patch8:     %{name}-2.0.8-wxpropgrid.patch

# http://sourceforge.net/p/saga-gis/patches/8/
# http://sourceforge.net/mailarchive/forum.php?thread_name=4F174B4F.8020006%40gwdg.de&forum_name=saga-gis-developer
# Vigra 1.8 has slight API changes
Patch9:     %{name}-2.0.8-vigra18.patch

BuildRequires: desktop-file-utils
BuildRequires: libtool automake autoconf
BuildRequires: e00compr-static
BuildRequires: g2clib-static
BuildRequires: gdal-devel 
BuildRequires: jasper-devel 
BuildRequires: libharu-devel
BuildRequires: libtiff-devel 
BuildRequires: polyclipping-devel
BuildRequires: proj-devel 
BuildRequires: python2-devel 
BuildRequires: qhull-devel 
BuildRequires: swig
BuildRequires: unixODBC-devel 
BuildRequires: vigra-devel
BuildRequires: wxGTK-devel 
BuildRequires: wxpropgrid-devel

%description
SAGA is a geographic information system (GIS) with a special API
for geographic data processing. This API makes it easy to implement
new algorithms. The SAGA API supports grid data, vector data, and tables. 

%package python
Summary:        SAGA Python interface
Group:          Applications/Engineering
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description python
Python interface for SAGA

%package devel
Summary:        SAGA development package
Group:          Applications/Engineering
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
This package includes the headers and development libraries for SAGA.

# We don't want to provide private Python extension libs
# This approach only works with rpm 4.9
# See https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Usage and https://fedorahosted.org/fpc/ticket/76
%global __provides_exclude_from ^%{python_sitearch}/.*\.so$

%prep
%setup -q -n %{name}-%{version}-fedora
sed -i 's/\r//' AUTHORS

# Delete bundled g2clib, e00compr,
# wxpropgrid, polyclipping and triangle (qhull)
rm -rf src/modules_io/grid/io_grid_grib2/g2clib-1.0.4
rm -rf src/modules_io/esri_e00/io_esri_e00/e00compr
rm -rf src/saga_core/saga_gui/wx
rm -f src/saga_core/saga_api/clipper.{c,h}pp
rm -rf src/modules/grid/grid_gridding/nn/triangle.*

%patch1 -p1 -b .~qhull
%patch2 -p1 -b .~libfire
%patch3 -p1 -b .~grib2
%patch4 -p1 -b .~g2clib
%patch5 -p1 -b .~dxflib
%patch6 -p1 -b .~e00
%patch7 -p1 -b .~poly
%patch8 -p1 -b .~wxpropgrid

%if 0%{?fedora} > 16
%patch9 -p0 -b .~vigra
%endif

# Update FSF address
# https://sourceforge.net/tracker/?func=detail&aid=3404676&group_id=102728&atid=632652
find . -name "*.cpp" -exec sed -i 's/59 Temple Place[ ]*[,-] Suite 330, Boston, MA[ ]*02111-1307/51 Franklin Street, Fifth Floor, Boston, MA  02110-1301/' {} \;
find . -name "*.h" -exec sed -i 's/59 Temple Place[ ]*[-,] Suite 330, Boston, MA[ ]*02111-1307/51 Franklin Street, Fifth Floor, Boston, MA  02110-1301/' {} \;


%build
autoreconf -fi
%configure --enable-unicode --disable-static --enable-python

# Get rid of undesirable hardcoded rpaths; workaround libtool reordering
# -Wl,--as-needed after all the libraries.
sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|^LTCC="gcc"|LTCC="gcc -Wl,--as-needed"|' \
    -e 's|^CC="g++"|CC="g++ -Wl,--as-needed"|' \
    -i libtool

make %{?_smp_mflags}


%install
make install DESTDIR=%{buildroot}

# Drop libtool archives
rm -rf %{buildroot}/%{_libdir}/saga/lib*.la     \
     %{buildroot}/%{_libdir}/saga/libsaga_*.la
rm -rf %{buildroot}/%{python_sitearch}/*.la     \
     %{buildroot}/%{_libdir}/*.la

desktop-file-install                                   \
    --dir=%{buildroot}%{_datadir}/applications         \
    %{SOURCE1}

# Install headers
# https://sourceforge.net/tracker/?func=detail&aid=3407467&group_id=102728&atid=632652
for dir in api gdi odbc; do
    mkdir -p %{buildroot}%{_includedir}/%{name}/%{name}_$dir
    install -pm 0644 -t %{buildroot}%{_includedir}/%{name}/%{name}_$dir  \
        src/%{name}_core/%{name}_$dir/*.h  
done

# Install icon
mkdir  %{buildroot}%{_datadir}/pixmaps/
install -p -m644 src/%{name}_core/%{name}_gui/res/xpm/%{name}_icon_32.xpm \
    %{buildroot}%{_datadir}/pixmaps/%{name}.xpm


%files
%doc COPYING AUTHORS ChangeLog
%{_bindir}/%{name}_cmd
%{_bindir}/%{name}_gui
%{_libdir}/%{name}
#TODO: Ask developers about soname versioning (and order!)
%{_libdir}/lib%{name}_api-%{version}.so
%{_libdir}/lib%{name}_gdi-%{version}.so
%{_libdir}/lib%{name}_odbc-%{version}.so
%{_datadir}/pixmaps/%{name}.xpm
%{_datadir}/applications/%{name}.desktop
%{_mandir}/man1/%{name}_*1*

%files python
%{python_sitearch}/*.py*
%{python_sitearch}/*.so

%files devel
%{_includedir}/%{name}/%{name}_*
%{_libdir}/lib%{name}_api.so
%{_libdir}/lib%{name}_gdi.so
%{_libdir}/lib%{name}_odbc.so

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig


%changelog
* Tue Jan  8 2013 Volker Fröhlich <volker27@gmx.at> - 2.0.8-8
- Rebuild for polyclipping

* Thu Dec 26 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-7
- Rebuild for polyclipping

* Fri Nov 23 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-6
- Rebuild for polyclipping

* Fri Oct 19 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-5
- Correct isa macros
- No later versions of GPL and LGPL are allowed
- Break down licenses
- Solve the rpath issue differently
- Rename patches and change numbering

* Tue Oct  9 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-4
- Remove draft patch breaking the build

* Sun Oct  7 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-3
- Replace provides-filtering with a suitable method
- Replace dos2unix invocation with sed

* Thu Apr 11 2012 Volker Fröhlich <volker27@gmx.at> - 2.0.8-2
- Build with system-wide wxpropgrid and polyclipping
- Correct Exec entry in the desktop file
- Update patch for e00compr

* Thu Nov 24 2011 Volker Fröhlich <volker27@gmx.at> - 2.0.8-1
- Updated for new version
- Drop obsolete patches gcc46 and python-parallel
- Correct tarball script
- Update and correct linking in g2clib patch

* Sun Oct 30 2011 Volker Fröhlich <volker27@gmx.at> - 2.0.7-3
- Delete dxflib from tarball
- Split patches for dxflib and e00compr
- Use bundled wxpropgrid for the time being
- Use system-wide e00compr

* Fri Oct 08 2011 Volker Fröhlich <volker27@gmx.at> - 2.0.7-2
- Correct g2clib patch to actually use g2clib
- Only link to libraries actually used
- Fix configure.in to really search for lodbc
- Require g2clib-static instead of -devel

* Fri Sep 09 2011 Volker Fröhlich <volker27@gmx.at> - 2.0.7-1
- Initital package
